Bug 728441 - kobo.django.menu.MainMenu doesn't work with Django 1.3
Summary: kobo.django.menu.MainMenu doesn't work with Django 1.3
Keywords:
Status: CLOSED EOL
Alias: None
Product: Fedora
Classification: Fedora
Component: kobo
Version: 19
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Daniel Mach
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 728448
TreeView+ depends on / blocked
 
Reported: 2011-08-05 07:56 UTC by Martin Magr
Modified: 2015-02-18 11:20 UTC (History)
1 user (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-02-18 11:20:22 UTC


Attachments (Terms of Use)
MainMenu patch (1.69 KB, patch)
2011-08-05 18:56 UTC, Martin Magr
no flags Details | Diff

Description Martin Magr 2011-08-05 07:56:28 UTC
MainMenu object is not rendered properly in Django 1.3 templates.

Comment 1 Martin Magr 2011-08-05 10:39:42 UTC
So the problem is that: 'MainMenu' object has no attribute 'alters_data'.

From my investigation in Django source code and documentation:

Changed in Django 1.3: Previously, only variables that originated with an attribute lookup would be called by the template system. This change was made for consistency across lookup types.
...
A variable can only be called if it has no required arguments. Otherwise, the system will return an empty string. Obviously, there can be side effects when calling some variables, and it'd be either foolish or a security hole to allow the template system to access them.

More info here: https://docs.djangoproject.com/en/1.3/ref/templates/api/#rendering-a-context

Unfortunately, even adding 'self.alters_data = False' attribute to MainMenu and/or Menu class, didn't solve the problem (only exception is not raise, but menu is still not rendered). I'm going to further investigate.

Comment 2 Martin Magr 2011-08-05 11:26:37 UTC
Menu rendering could be fixed with making MainMenu _not_ callable. Which means moving operations from __call__ to (for example) LazyMenu.__get__. But this is only workaround, which doesn't solve the cause of the problem.

Do you want me to write such a patch?

Comment 3 Daniel Mach 2011-08-05 13:03:01 UTC
(In reply to comment #2)
> Menu rendering could be fixed with making MainMenu _not_ callable. Which means
> moving operations from __call__ to (for example) LazyMenu.__get__. But this is
> only workaround, which doesn't solve the cause of the problem.
> 
> Do you want me to write such a patch?

Even a hack is definitely better than nothing.
But if you can write something which is not a workaround, please do so.

Comment 4 Martin Magr 2011-08-05 18:56:44 UTC
Created attachment 516937 [details]
MainMenu patch

Attached is the patch. I think that it would not be possible to preserve MainMenu as callable object. According to Django 1.3 documentation every callable variable in templates must not accept any attribute.

Comment 5 Daniel Mach 2011-08-23 11:33:12 UTC
pushed to git

Comment 6 Martin Magr 2012-12-19 15:37:14 UTC
Setting to VERIFIED since we use MainMenu successfully with Django-1.3

Comment 7 Fedora End Of Life 2013-04-03 20:39:39 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 19 development cycle.
Changing version to '19'.

(As we did not run this process for some time, it could affect also pre-Fedora 19 development
cycle bugs. We are very sorry. It will help us with cleanup during Fedora 19 End Of Life. Thank you.)

More information and reason for this action is here:
https://fedoraproject.org/wiki/BugZappers/HouseKeeping/Fedora19

Comment 8 Fedora End Of Life 2015-01-09 22:41:28 UTC
This message is a notice that Fedora 19 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 19. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained. Approximately 4 (four) weeks from now this bug will
be closed as EOL if it remains open with a Fedora 'version' of '19'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 19 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 9 Fedora End Of Life 2015-02-18 11:20:22 UTC
Fedora 19 changed to end-of-life (EOL) status on 2015-01-06. Fedora 19 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.


Note You need to log in before you can comment on or make changes to this bug.